ServantLocatorPOA (Java Platform SE 8 )
Keywords: org.omg.PortableServer.ServantLocatorPOA class
Date: 2023-01-18

org.omg.PortableServer

## Class ServantLocatorPOA

- java.lang.Object
- - org.omg.PortableServer.Servant
  - - org.omg.PortableServer.ServantLocatorPOA

- All Implemented Interfaces:
    InvokeHandler, ServantLocatorOperations, ServantManagerOperations

      public abstract class ServantLocatorPOA
      extends Servant
      implements ServantLocatorOperations, InvokeHandler

  When the POA has the NON_RETAIN policy it uses servant managers that are ServantLocators. Because the POA knows that the servant returned by this servant manager will be used only for a single request, it can supply extra information to the servant manager's operations and the servant manager's pair of operations may be able to cooperate to do something different than a ServantActivator. When the POA uses the ServantLocator interface, immediately after performing the operation invocation on the servant returned by preinvoke, the POA will invoke postinvoke on the servant manager, passing the ObjectId value and the Servant value as parameters (among others). This feature may be used to force every request for objects associated with a POA to be mediated by the servant manager.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ServantLocatorPOA()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `String[]` | `_all_interfaces(POA poa, byte[] objectId)` Used by the ORB to obtain complete type information from the servant.
    `OutputStream` | `_invoke(String $method, InputStream in, ResponseHandler $rh)` Invoked by the ORB to dispatch a request to the servant.
    `ServantLocator` | `_this()`
    `ServantLocator` | `_this(ORB orb)`

    - ### Methods inherited from class org.omg.PortableServer.Servant

      `_default_POA, _get_delegate, _get_interface_def, _is_a, _non_existent, _object_id, _orb, _poa, _set_delegate, _this_object, _this_object`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.omg.PortableServer.ServantLocatorOperations

      `postinvoke, preinvoke`

- - ### Constructor Detail

    - #### ServantLocatorPOA

          public ServantLocatorPOA()

  - ### Method Detail

    - #### _invoke

          public OutputStream _invoke(String $method,
                                      InputStream in,
                                      ResponseHandler $rh)

      Description copied from interface: `InvokeHandler`
      Invoked by the ORB to dispatch a request to the servant. ORB passes the method name, an InputStream containing the marshalled arguments, and a ResponseHandler which the servant uses to construct a proper reply. Only CORBA SystemException may be thrown by this method. The method must return an OutputStream created by the ResponseHandler which contains the marshalled reply. A servant must not retain a reference to the ResponseHandler beyond the lifetime of a method invocation. Servant behaviour is defined as follows:

      1. Determine correct method, and unmarshal parameters from InputStream.

      2. Invoke method implementation.

      3. If no user exception, create a normal reply using ResponseHandler.

      4. If user exception occurred, create exception reply using ResponseHandler.

      5. Marshal reply into OutputStream returned by ResponseHandler.

      6. Return OutputStream to ORB.

      Specified by:
        `_invoke` in interface `InvokeHandler`
      Parameters:
        `$method` - The method name.
        `in` - The `InputStream` containing the marshalled arguments.
        `$rh` - The `ResponseHandler` which the servant uses to construct a proper reply
      Returns:
        The `OutputStream` created by the ResponseHandler which contains the marshalled reply

    - #### _all_interfaces

          public String[] _all_interfaces(POA poa,
                                          byte[] objectId)

      Description copied from class: `Servant`
      Used by the ORB to obtain complete type information from the servant.
      Specified by:
        `_all_interfaces` in class `Servant`
      Parameters:
        `poa` - POA with which the servant is associated.
        `objectId` - is the id corresponding to the object associated with this servant.
      Returns:
        list of type information for the object.

    - #### _this

          public ServantLocator _this()

    - #### _this

          public ServantLocator _this(ORB orb)

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2023, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.